# igvita.com (Ilya Grigorik)
require 'rubygems'
require 'socket' 

class NetworkLogger  
  def initialize(host = 'localhost', port = '8888')
    @socket = TCPSocket.new(host, port)
  end
     
  def log(level, msg)
    @socket.write "#{Time.new.strftime("%H:%M:%S")} (#{level}): #{msg}\n"
  end
  
  def method_missing(method, *args)
    if method.to_s =~ /(info|debug|warn|error)/i
      return self.log(method.to_s, args[0])
    end 
  end
end

logger = NetworkLogger.new('localhost', 9998)

# Send log messages to remote Splunk server 
logger.info "This is in INFO message"
logger.debug "This is a DEBUG message"
logger.warn "This is a WARNING message"
logger.error "Uh oh! This is an ERROR message"